#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
# License: GNU General Public License v2
#
# Author: thl-cmk[at]outlook[dot]com
# URL   : https://thl-cmk.hopto.org
# Date  : 2024-07-16
# File  : vsphere_topo/lib/ruelset_names.py

from enum import Enum, unique
from os import environ
from typing import Final


ICON_VCENTER: Final[str] = 'icon_topic_hosts'
RULE_SET_NAME_VSPHERE_TOPO: Final[str] = 'vsphere_topo'
TOPOLOGY_NAME: Final[str] ='vSphere'
OMD_ROOT = environ['OMD_ROOT']
BASE_TOPO_PATH: Final[str] = f'{OMD_ROOT}/var/check_mk/topology/data'

class EnumValue(Enum):
    def __get__(self, instance, owner):
        return self.value

@unique
class Emblem(EnumValue):
    CLUSTER: Final[str] = 'icon_plugins_hw'
    DATA_CENTER: Final[str] = 'icon_cloud'
    DATA_STORE: Final[str] = 'icon_services_green'

@unique
class Param(EnumValue):
    CHANGE_CASE: Final[str] = 'change_case'
    CLUSTER: Final[str] = 'cluster'
    CUSTOM_EMBLEM: Final[str] = 'custom_emblem'
    DATA_CENTER: Final[str] = 'data_center'
    DATA_STORE: Final[str] = 'data_store'
    DATA_STORE_AS_SERVICE: Final[str] = 'data_sore_as_service'
    DEFAULT_EMBLEM: Final[str] = 'default_emblem'
    HOST_SYSTEMS: Final[str] = 'host_systems'
    IGNORE_POWERED_OFF_VMS: Final[str] = 'ignore_powered_off_vms'
    IGNORE_VM_NAME_REGEX: Final[str] = 'ignore_vms_by_name'
    KEEP_DOMAIN: Final[str] = 'keep_domain'
    LOWER: Final[str] = 'lower'
    MAKE_DEFAULT: Final[str] = 'make_default'
    MAP_NAMES: Final[str] = 'map_names'
    MAP_NAME_CMK: Final[str] = 'name_cmk'
    MAP_NAME_VSPHERE: Final[str] = 'name_vsphere'
    NO_CHANGE: Final[str] = 'no_change'
    NO_EMBLEM: Final[str] = 'no_emblem'
    PREFIX: Final[str] = 'prefix'
    SUFFIX: Final[str] = 'suffix'
    UPPER: Final[str] = 'upper'
    VCENTER: Final[str] = 'vcenter_icon'
    VM_NAMES: Final[str] = 'vm_names'

@unique
class Picture(EnumValue):
    TYPE_EMBLEM: Final[str] = 'emblem'
    TYPE_ICON: Final[str] = 'icon'
